#include "MPDTestMain.h"

#include <stdlib.h>

#include <PPobClasses.h>
#include <LGroupBox.h>
#include <UMemoryMgr.h>
#include <UDrawingState.h>
#include <LGrowZone.h>
#include <LActiveScroller.h>
#include <URegistrar.h>

#define USE_AGA_CLASSES 0
#include "CMPDPanelSelectTable.h"
#include "CMPDIncludeView.h"
#include "CIncludeView.h"
#include "UTestPrefsDialogHandler.h"
#include "CCommunicationPanel.h"
#include "CDefensePanel.h"
#include "CPowerPanel.h"
#include "CTargeterBorder.h"
#ifdef USE_AGA_CLASSES
//LAGA Classes
	#include "CMPDAGAIndexTab.h"
	#include "LAGADialogBox.h"
	#include "LAGAPushButton.h"
	#include "LAGACheckBox.h"
	#include "LAGARadioButton.h"
	#include "LAGAEditField.h"
	#include "LAGAGroupBox.h"

// Gray Council classes
	#include "CMPDGrayCouncilTabs.h"
	#include "GrayCouncilPP.h"
#endif

// put declarations for resource ids (ResIDTs) here
const CommandT	cmd_Prefs1			= 10000;
#ifdef USE_AGA_CLASSES
	const CommandT	cmd_Prefs2			= 10001;
	const CommandT	cmd_Prefs3			= 10002;
#endif
// ===========================================================================
//		 Main Program
// ===========================================================================
void main(void)
{
	SetDebugThrow_(debugAction_Alert);
	SetDebugSignal_(debugAction_Alert);

	InitializeHeap(10);
	UQDGlobals::InitializeToolbox(&qd);
	
	new LGrowZone(20000);
	CPPStarterApp	theApp;
	theApp.Run();
}


CPPStarterApp::CPPStarterApp()
{
	RegisterAllPPClasses();
	URegistrar::RegisterClass(CMPDPanelSelectTable::class_ID,		
													(ClassCreatorFunc)CMPDPanelSelectTable::CreateFromStream);
	URegistrar::RegisterClass(CMPDIncludeView::class_ID,		
													(ClassCreatorFunc)CMPDIncludeView::CreateFromStream);
	URegistrar::RegisterClass(CIncludeView::class_ID,		
													(ClassCreatorFunc)CIncludeView::CreateFromStream);
	URegistrar::RegisterClass(CCommunicationPanel::class_ID,		
													(ClassCreatorFunc)CCommunicationPanel::CreateFromStream);
	URegistrar::RegisterClass(CDefensePanel::class_ID,		
													(ClassCreatorFunc)CDefensePanel::CreateFromStream);
	URegistrar::RegisterClass(CPowerPanel::class_ID,		
													(ClassCreatorFunc)CPowerPanel::CreateFromStream);
	URegistrar::RegisterClass(CTargeterBorder::class_ID,		
													(ClassCreatorFunc)CTargeterBorder::CreateFromStream);
	URegistrar::RegisterClass(LGroupBox::class_ID,		
													(ClassCreatorFunc)LGroupBox::CreateGroupBoxStream);
	URegistrar::RegisterClass(LActiveScroller::class_ID,		
													(ClassCreatorFunc)LActiveScroller::CreateActiveScrollerStream);
#ifdef USE_AGA_CLASSES
// LAGA classes
	URegistrar::RegisterClass(CMPDAGAIndexTab::class_ID,		
										(ClassCreatorFunc)CMPDAGAIndexTab::CreateFromStream);
	URegistrar::RegisterClass(LAGADialogBox::class_ID, 
										(ClassCreatorFunc)LAGADialogBox::CreateAGADialogBoxStream);
	URegistrar::RegisterClass(LAGAPushButton::class_ID, 
										(ClassCreatorFunc)LAGAPushButton::CreateAGAPushButtonStream);
	URegistrar::RegisterClass(LAGACheckBox::class_ID, 
										(ClassCreatorFunc)LAGACheckBox::CreateAGACheckBoxStream);
	URegistrar::RegisterClass(LAGARadioButton::class_ID, 
										(ClassCreatorFunc)LAGARadioButton::CreateAGARadioButtonStream);
	URegistrar::RegisterClass(LAGAGroupBox::class_ID, 
										(ClassCreatorFunc)LAGAGroupBox::CreateAGAGroupBoxStream);
	URegistrar::RegisterClass(LAGAEditField::class_ID, 
										(ClassCreatorFunc)LAGAEditField::CreateAGAEditFieldStream);

// Gray Council classes
	ThrowIfOSErr_(InitGrayCouncil());

	URegistrar::RegisterClass(CMPDGrayCouncilTabs::class_ID,		
										(ClassCreatorFunc)CMPDGrayCouncilTabs::CreateFromStream);
	URegistrar::RegisterClass(AGADialogBoxPP::class_ID, 
										(ClassCreatorFunc)AGADialogBoxPP::CreateStream);
	URegistrar::RegisterClass(AGAPushButtonPP::class_ID, 
										(ClassCreatorFunc)AGAPushButtonPP::CreateStream);
	URegistrar::RegisterClass(AGACheckBoxPP::class_ID, 
										(ClassCreatorFunc)AGACheckBoxPP::CreateStream);
	URegistrar::RegisterClass(AGARadioButtonPP::class_ID, 
										(ClassCreatorFunc)AGARadioButtonPP::CreateStream);
	URegistrar::RegisterClass(AGAGroupBoxPP::class_ID, 
										(ClassCreatorFunc)AGAGroupBoxPP::CreateStream);
	URegistrar::RegisterClass(AGAEditFieldPP::class_ID, 
										(ClassCreatorFunc)AGAEditFieldPP::CreateStream);
	URegistrar::RegisterClass(AGAPopupMenuPP::class_ID, 
										(ClassCreatorFunc)AGAPopupMenuPP::CreateStream);
#endif
}


CPPStarterApp::~CPPStarterApp()
{
}

Boolean
CPPStarterApp::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand) 
	{
		case cmd_Prefs1:
#ifdef USE_AGA_CLASSES
		case cmd_Prefs2:
		case cmd_Prefs3:
#endif
			StTestPrefsDialogHandler::GetPreferences(this, inCommand);
			break;

		default:
			cmdHandled = LApplication::ObeyCommand(inCommand, ioParam);
			break;
	}
	
	return cmdHandled;
}

void
CPPStarterApp::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{

	switch (inCommand) 
	{
		case cmd_Prefs1:
#ifdef USE_AGA_CLASSES
		case cmd_Prefs2:
		case cmd_Prefs3:
#endif
			outEnabled = true;
			break;

		default:
			LApplication::FindCommandStatus(inCommand, outEnabled,
												outUsesMark, outMark, outName);
			break;
	}
}
